<?php
namespace Twoir\System\Model;

/**
 * 栏目
 * 2022.05.05
*/

use Twoir\System\Support\ParseTrait;

class EnewsClass
{
	use ParseTrait;
	
	const TABLE = [
		'pri'	=> 'enewsclass',	//主表
		'sec'	=> 'enewsclassadd'	//副表
	];
	
	//主键字段
	const PRIMARY = 'classid';

	const FIELD = [
		'pri'	=> [
			'classid','bclassid','classname','sonclass','is_zt','lencord','link_num','newstempid','onclick','listtempid','featherclass','islast','classpath','classtype','newspath','filename',
			'filetype','openpl','openadd','newline','hotline','goodline','classurl','groupid','myorder','filename_qz','hotplline','modid','checked','firstline','bname','islist','searchtempid','tid',
			'tbname','maxnum','checkpl','down_num','online_num','listorder','reorder','intro','classimg','jstempid','addinfofen','listdt','showclass','showdt','checkqadd','qaddlist','qaddgroupid',
			'qaddshowkey','adminqinfo','doctime','classpagekey','dtlisttempid','classtempid','nreclass','nreinfo','nrejs','nottobq','ipath','addreinfo','haddlist','sametitle','definfovoteid','wburl',
			'qeditchecked','wapstyleid','repreinfo','pltempid','cgroupid','yhid','wfid','cgtoinfo','bdinfoid','repagenum','keycid','allinfos','infos','addtime','oneinfo','addsql','wapislist','fclast'
			
			//自定义
		],
		'sec'	=> [
			'classid', 'classtext', 'ttids', 'eclasspagetext'
			
			//自定义
		]
	];
	
	/**
	 * 默认值
	 */
	const MYDEFAULT = [
		'pri'	=> [
			'classid'		=> null,
			'bclassid'		=> 0,
			'classname'		=> '',
			'sonclass'		=> '',
			'is_zt'			=> 0,
			'lencord'		=> 0,
			'link_num'		=> 0,
			'newstempid'	=> 0,
			'onclick'		=> 0,
			'listtempid'	=> 0,
			'featherclass'	=> '',
			'islast'		=> 0,
			'classpath'		=> '',
			'classtype'		=> '',
			'newspath'		=> '',
			'filename'		=> 0,
			'filetype'		=> '',
			'openpl'		=> 0,
			'openadd'		=> 0,
			'newline'		=> 0,
			'hotline'		=> 0,
			'goodline'		=> 0,
			'classurl'		=> '',
			'groupid'		=> 0,
			'myorder'		=> 0,
			'filename_qz'	=> '',
			'hotplline'		=> 0,
			'modid'			=> 0,
			'checked'		=> 0,
			'firstline'		=> 0,
			'bname'			=> '',
			'islist'		=> 0,
			'searchtempid'	=> 0,
			'tid'			=> 0,
			'tbname'		=> '',
			'maxnum'		=> 0,
			'checkpl'		=> 0,
			'down_num'		=> 0,
			'online_num'	=> 0,
			'listorder'		=> '',
			'reorder'		=> '',
			'intro'			=> '',
			'classimg'		=> '',
			'jstempid'		=> 0,
			'addinfofen'	=> 0,
			'listdt'		=> 0,
			'showclass'		=> 0,
			'showdt'		=> 0,
			'checkqadd'		=> 0,
			'qaddlist'		=> 0,
			'qaddgroupid'	=> '',
			'qaddshowkey'	=> 0,
			'adminqinfo'	=> 0,
			'doctime'		=> 0,
			'classpagekey'	=> '',
			'dtlisttempid'	=> 0,
			'classtempid'	=> 0,
			'nreclass'		=> 0,
			'nreinfo'		=> 0,
			'nrejs'			=> 0,
			'nottobq'		=> 0,
			'ipath'			=> '',
			'addreinfo'		=> 0,
			'haddlist'		=> 0,
			'sametitle'		=> 0,
			'definfovoteid'	=> 0,
			'wburl'			=> '',
			'qeditchecked'	=> 0,
			'wapstyleid'	=> 0,
			'repreinfo'		=> 0,
			'pltempid'		=> 0,
			'cgroupid'		=> 0,
			'yhid'			=> 0,
			'wfid'			=> 0,
			'cgtoinfo'		=> 0,
			'bdinfoid'		=> '',
			'repagenum'		=> 0,
			'keycid'		=> 0,
			'allinfos'		=> 0,
			'infos'			=> 0,
			'addtime'		=> 0,
			'oneinfo'		=> 0,
			'addsql'		=> '',
			'wapislist'		=> 0,
			'fclast'		=> 0
			
			//自定义
		],
		'sec'	=> [
			'classid'		=> null, 
			'classtext'		=> '', 
			'ttids'			=> '', 
			'eclasspagetext'=> ''
			
			//自定义
		]
	];
	
	//操作类型符号
	const OPERATE = ['>', '<', 'in', 'like', ' '];
	
	/**
	 * 
	 * @param array $where = {key => val},
	 * @return int
	 */
	public static function getTotal($where = [], $index = 'pri')
	{
		global $empire, $dbtbpre;
		
		//默认值
		$index = null === $index || empty($index) ? 'pri' : $index;
		
		$sql = sprintf("SELECT count(*) as total FROM %s%s", $dbtbpre . self::TABLE[$index], self::parseWhere($where, false));
		
		return (int)$empire->gettotal($sql);
	}
	
	/**
	 * 拉取一条数据
	 * @param $where 键值数组 $field 值数组
	 * 
	*/
	public static function getOne($where = [], $field = ['*'], $orderby = '', $type = '')
	{
		$res = self::getList($where, $field, 0, 1, $orderby, $type);
	    
	    return $res ? array_values($res)[0] : [];
	}
	
	/**
	 * 读取多条(列表)
	 * @return array
	 */
	public static function getList($where = [], $field = ['*'], $limit = 0, $pagesize = 10, $orderby = '', $type = '')
	{
	 global $empire, $dbtbpre;

	 $get_field  = $field;
	 $get_where  = array_keys($where);
	 $pri_where  = array_filter(self::FIELD['pri'], function($item) use ($get_where) {return !in_array($item, ['classid', 'id']) && in_array($item, $get_where);});
	 $sec_where  = array_filter(self::FIELD['sec'], function($item) use ($get_where) {return !in_array($item, ['classid', 'id']) && in_array($item, $get_where);});

	 //提取 where字段
	 if (['*'] !== $field && is_array($where) && !empty($where)) {
		 
		 $where_field= array_map(function($item) {return str_replace(self::OPERATE, '', $item);}, $get_where);
		 $get_field  = array_merge($get_field, $where_field);
	 }
	 
	 $option = [];   
	 foreach(self::TABLE as $t => $table) {
		 
		 $get_field  = ['*'] === $field ? self::FIELD[$t] : array_intersect(self::FIELD[$t], $get_field);
		 $count      = count($get_field);

		 if ($count > 1 || (1 === $count && !in_array('classid', $get_field))) {
			 
			 //增加主键
			 ['*'] === $field or array_push($get_field, self::PRIMARY);
			 
			 $option[$t] = [
				 'field'     => '`' . implode('`,`', $get_field) . '`',
				 'table'     => $dbtbpre . $table,
				 'where'     => empty($where) ? '' : self::parseWhere($where, false),
				 'order'     => null === $orderby || '' === $orderby ? '' : ' ORDER BY ' . $orderby,
				 'limit'     => 1 === $pagesize ? 'limit 1' : 'limit ' . ($limit * $pagesize) . ',' . $pagesize,
				'page'		=> $pagesize < 1 || $pagesize > 9999 ? 10 : $pagesize, //大于9999默认为10
			 ];
		 }
	 }

	 $res = [];
	 
	 //主键调
	 if (!empty($get_where) && in_array('classid', $get_where) && empty($pri_where) && empty($sec_where)) {

		 //主表
		 if (isset($option['pri'])) {
			 
			$sql = sprintf("SELECT %s FROM %s%s%s %s", $option['pri']['field'], $option['pri']['table'], $option['pri']['where'], $option['pri']['order'], $option['pri']['limit']);
			$sql = $empire->query($sql);

			if(0 < $empire->num1($sql)){
				 
				while($r = $empire->fetch($sql)){
					 
					//去数字键
					$res[$r['classid']] = array_filter($r, function($key) {return is_string($key);}, ARRAY_FILTER_USE_KEY);
				}
			}
		 }

		 //副表
		 if (isset($option['sec'])) {
			 
			$sql = sprintf("SELECT %s FROM %s%s%s %s", $option['sec']['field'], $option['sec']['table'], $option['sec']['where'], $option['sec']['order'], $option['sec']['limit']);
			$sql = $empire->query($sql);

			if(0 < $num = $empire->num1($sql)){
				 
				 while($r = $empire->fetch($sql)){
					 
					//去数字键
					$r = array_filter($r, function($key) {return is_string($key);}, ARRAY_FILTER_USE_KEY);
					
					//合并
					$res[$r['classid']] = isset($res[$r['classid']]) ? array_merge($res[$r['classid']], $r) : $r;
				 }
			}
		 }  
	 }
	 //非主键(查询where在主表上)
	 elseif (empty($where) || (!empty($pri_where) && empty($sec_where))) {

		 //主表
		 if (isset($option['pri'])) {

			$sql = sprintf("SELECT %s FROM %s%s%s %s", $option['pri']['field'], $option['pri']['table'], $option['pri']['where'], $option['pri']['order'], $option['pri']['limit']);
			$sql = $empire->query($sql);
			$in_where = [];

			if(0 < $empire->num1($sql)){
				 
				 while($r = $empire->fetch($sql)){
					 
					$in_where[] = $r['classid'];
					 
					//去数字键
					$res[$r['classid']] = array_filter($r, function($key) {return is_string($key);}, ARRAY_FILTER_USE_KEY);
				 }
			}
		 }

		 //副表
		 if (isset($option['sec'], $in_where) && !empty($in_where)) {

			$sql = sprintf("SELECT %s FROM %s%s%s %s", $option['sec']['field'], $option['sec']['table'], count($in_where) > 1 ? ' WHERE classid IN (' . implode(',', $in_where) . ')' : ' WHERE classid = ' . $in_where[0], $option['sec']['order'], $option['sec']['limit']);
			$sql = $empire->query($sql);

			if(0 < $num = $empire->num1($sql)){
				 
				 while($r = $empire->fetch($sql)){
					 
					 $r = array_filter($r, function($key) {return is_string($key);}, ARRAY_FILTER_USE_KEY);
					 //去数字键
					 $res[$r['classid']] = isset($res[$r['classid']]) ? array_merge($res[$r['classid']], $r) : $r;
				 }
			}
		 }  
	 }
	 //副表上， 用联表方式/先查副表再到主表
	 else {

		 return [];
	 }
	 
	 return $res;
	}
}