<?php
namespace Twoir\System\Model;

/***
 * 数据处理
 * 查询getTotal
*/

use Twoir\System\Support\ParseTrait;

class Enewsf
{
	use ParseTrait;
	
	const TABLE = 'enewsf';
	
	//
	const FIELD = [
		'fid','f','fname','fform','fhtml','fzs','isadd','isshow','iscj','cjhtml','myorder','ftype','flen','dotemp','tid','tbname','savetxt','fvalue','iskey','tobr','dohtml','qfhtml','isonly',
		'linkfieldval','samedata','fformsize','tbdataf','ispage','adddofun','editdofun','qadddofun','qeditdofun','linkfieldtb','linkfieldshow',	'editorys','issmalltext','fmvnum'
	];
	
	/**
	 * 统计数量
	 * @param array $where = {key => val},
	 * @return int
	 */
	public static function getTotal($where = [])
	{
		global $empire, $dbtbpre;
		
		$sql = sprintf("SELECT count(*) as total FROM %s%s", $dbtbpre . self::TABLE, self::parseWhere($where, false));
		
		return (int)$empire->gettotal($sql);
	}
	
	/**
	 * 读取当条信息 
	 * @param array $where = {key => val}, array $field = {item,item2}
	 * @return array []
	 */
	public static function getOne($where = [], $field = ['*'], $orderby = '')
	{
	    $res = self::getList($where, $field, 0, 1, $orderby);
	    
	    return $res ? $res[0] : [];
	}
	
	/**
	 * 读取多条(列表)
	 * @return array
	 */
	 public static function getList($where = [], $field = ['*'], $limit = 0, $pagesize = 10, $orderby = '')
	 {
	    global $empire, $dbtbpre;
	    
	    $str_field  = empty($field) || ['*'] === $field ? ' *' : '`' . implode('`,`', $field) . '`';
	    $pagesize   = $pagesize < 1 || $pagesize > 2000 ? 10 : $pagesize; //小于1或大于2000时 强制等于10
	    $str_limit  = 1 === $pagesize ? 'limit 1' : 'limit ' . ($limit * $pagesize) . ',' . $pagesize;
	    $str_orderby= empty($orderby) ? '' : ' ORDER BY ' . $orderby;
	    
	    $sql = sprintf("SELECT %s FROM %s%s%s %s", $str_field, $dbtbpre . self::TABLE, self::parseWhere($where, false), $str_orderby, $str_limit);
	    $sql = $empire->query($sql);
	    
	    $res = [];
	    
	    if(0 < $num = $empire->num1($sql)){
	        
	        while($r = $empire->fetch($sql)){
	            //去数字键
	            $res[] = array_filter($r, function($key) {	return is_string($key);}, ARRAY_FILTER_USE_KEY);
	        }
	    }
	
	     return $res;
	 }
}