<?php
namespace Twoir\System\Support;

/**
 * 构造查询方法
*/
trait ParseTrait
{
    /**
     * 询查构造
	 * @param $where = {key => val}, prepare = {true|false}
	 * @param return = {string};
	 */
    public static function parseWhere($where = [], $prepare = true)
	{
		$str = '';
		$eq = ' = ';
		$pre = '';
		foreach($where as $key => $value) {

			//增加空判断可以加快
			if (false !== strstr($key, ' ') && preg_match('/(\w+)\s+(>|<|in|like)/i', $key, $matches)) {

				//联表前缀
				$pre = false !== strstr($key, '.') ? strstr($key, '.', true) . '.' : '';
				$key = $matches[1];
				if ('in' === $matches[2] && is_array($value)) {

					$value  = array_values($value);
					$eq 	= 1 === count($value) ? ' = ' : ' ' . strtoupper($matches[2]);
					$value 	= 1 === count($value) ? "'" . $value[0] . "'" : "('" . implode("', '", $value) . "')";
				}
				else {

					$eq 	= ' ' . $matches[2] . ' ';
				}
			}

			//去除null值
			if (null !== $value) {
				
				//联表操作 等于情况
				if (false !== strstr($key, '.') && !isset($matches)) {

					$str .= ($str ? ' AND ' : '') . substr_replace($key, '.`', 1, 1) . '`' . $eq . ($prepare ? ':' . $key : (is_numeric($value) ? $value : "'" . $value . "'"));
				}
				//联表不相同时 一般 > < in like等请况
				elseif (false === strstr($key, '.') && isset($matches)) {

					$str .= ($str ? ' AND ' : '') . $pre . '`' . $key . '`' . $eq . ($prepare ? ':' . $key : $value);
				}
				else {
					
					$str .= ($str ? ' AND ' : '') . '`' . $key . '`' . $eq . ($prepare ? ':' . $key : (is_numeric($value) ? $value : "'" . $value . "'"));
				}
			}
		}

		return $str ? ' WHERE ' . $str : '';
	}
    
	/**
	 * 构造插入语句
	 */
	public static function parseInsert($data)
	{		
		$key 	= '`'. implode('`, `', array_keys($data)) . '`';
		
		//给字符串加上单引号
		$value  = array_map(function($val) {
			
			return is_numeric($val) ? $val : "'" . addslashes(RepPostStr($val)) . "'";
			
		}, array_values($data));
		
		return ['key' => $key, 'value' => implode(', ', $value)];
	}
}